// ==UserScript==
// @name           nicofetch
// @namespace      http://www.nicovideo.jp/
// @description    Add the nicofetch function for some web applications.
// @include        http://www.google.tld/reader/*
// @include        https://www.google.tld/reader/*
// @require        http://www.nicovideo.jp/local/nlMovieFetcher.js
// ==/UserScript==

(function() {
	if (!window.nlMovieFetcher) {
		GM_log("nlMovieFetcher not found."); return;
	}
	window.nlMovieFetcher.prototype.callAPI = function(param, callback) {
		GM_xmlhttpRequest({
			method: 'GET',
			url: "http://www.nicovideo.jp/cache/fetch?"+param,
			onload: callback
		});
	}
	const WATCH_URL = "http://www.nicovideo.jp/watch/";
	const HOSTNAME = document.location.host;
	const PATHNAME = document.location.pathname;
	
	function getVideoId(href) {
		if (href.indexOf(WATCH_URL) != 0)
			return null;
		return href.substring(href.lastIndexOf("/") + 1);
	}
	
	function appendFetchLink(target, id, frame, anchor) {
		var link = document.createElement('A');
		link.href = "javascript:void(0)";
		link.textContent = "fetch";
		link.addEventListener('click', function() {
			var fetcher = new window.nlMovieFetcher(id, link, frame, anchor);
			fetcher.fetch();
		}, false);
		var div = document.createElement('DIV');
		div.style.fontWeight = 'bold';
		div.style.marginBottom = '1px';
		div.textContent = "nlMovieFetcher: ";
		div.appendChild(link);
		target.appendChild(div);
	}
	
	var AppFunctions = [
		function() { // Google Reader
			if (HOSTNAME.indexOf("www.google.") != 0) return;
			if (PATHNAME.indexOf("/reader/")    != 0) return;
			document.body.addEventListener('DOMNodeInserted', function(e) {
				var element = e.target;
				if (!element.className || element.className.indexOf("entry") != 0)
					return;
				var anchor = element.getElementsByClassName("entry-title-link")[0];
				if (!anchor) return;
				var id = getVideoId(anchor.href);
				if (!id) return;
				var frame = (element.className.indexOf("entry-container") != -1) ?
						element : element.getElementsByClassName("entry-container")[0];
				appendFetchLink(anchor.parentNode.parentNode, id, frame, anchor);
			}, false);
		},
		function(){} // End of AppFunctions
	];
	for (i in AppFunctions) AppFunctions[i]();
	
})();
